var selectedItem;
var domainstring;
var addressstring;

var CA_CONST = {
	DOMAIN_LIST     : "com.kenmaz.confirm-address.domain-list",
	IS_NOT_DISPLAY  : "com.kenmaz.confirm-address.not-display",
	IS_COUNT_DOWN   : "com.kenmaz.confirm-address.is-countdown",
	IS_SKIP_BUTTON  : "com.kenmaz.confirm-address.is-skip-button",
	IS_CHECK_SUBJECT: "com.kenmaz.confirm-address.is-check-subject",
	IS_CHECK_SENDER : "com.kenmaz.confirm-address.is-check-sender",
	COUNT_DOWN_TIME : "com.kenmaz.confirm-address.cd-time",
	TREE_STYLE      : "com.kenmaz.confirm-address.tree-style"
};

function startup(){

	var sBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
	var bstrings = sBundle.createBundle("chrome://confirm-address/locale/confirm-address.properties");
	domainstring  = bstrings.GetStringFromName("confirm.setting.domain");
	addressstring = bstrings.GetStringFromName("confirm.setting.address");

	//init domain list.
	document.getElementById("add"   ).addEventListener('command', add   , true);
	document.getElementById("edit"  ).addEventListener('command', edit  , true);
	document.getElementById("remove").addEventListener('command', remove, true);
	var groupList = document.getElementById("group-list");

	var domains = nsPreferences.copyUnicharPref(CA_CONST.DOMAIN_LIST);
	dump("[registed domains] " + domains + "\n");
	
	if(domains != null){
		var domainList = domains.split(",");
		for(var i=0; i < domainList.length; i++){
			var listitem = document.createElement("listitem");
			listitem.setAttribute("id", Math.random());
			
			var cell1 = document.createElement("listcell");
			cell1.setAttribute("label", domainList[i]);
			cell1.setAttribute("id", Math.random());
			listitem.appendChild(cell1);
			
			var cell2 = document.createElement("listcell");
			if( domainList[i].indexOf("@") != -1 ){
				cell2.setAttribute("label", addressstring );
			}else{
				cell2.setAttribute("label", domainstring );
			}
			cell2.setAttribute("id", Math.random());
			listitem.appendChild(cell2);

			groupList.appendChild(listitem);
		}
	}
	
	document.getElementById("chk-sender" ).checked = nsPreferences.getBoolPref(CA_CONST.IS_CHECK_SENDER , false);
	document.getElementById("chk-subject").checked = nsPreferences.getBoolPref(CA_CONST.IS_CHECK_SUBJECT, false);
	document.getElementById("not-display").checked = nsPreferences.getBoolPref(CA_CONST.IS_NOT_DISPLAY  , false);

	//init checkbox [countdown]
	var cdBox = document.getElementById("countdown");
	var cdTimeBox = document.getElementById("countdown-time");
	var cdSkipButton = document.getElementById("dspskipbtn");
	var isCountDown = nsPreferences.getBoolPref(CA_CONST.IS_COUNT_DOWN, false);

	cdBox.checked =  isCountDown;
	cdBox.addEventListener('command',
		function(event){
			cdTimeBox.disabled    = !cdBox.checked;
			cdSkipButton.disabled = !cdBox.checked;
		},
		true);

	cdTimeBox.disable     = !isCountDown;
	cdTimeBox.value = nsPreferences.copyUnicharPref(CA_CONST.COUNT_DOWN_TIME);

	cdSkipButton.disable  = !isCountDown;
	cdSkipButton.checked  = nsPreferences.getBoolPref(CA_CONST.IS_SKIP_BUTTON, true);
}

function add(event){
	window.confirmOK = false;
	window.domainName = null;
	window.openDialog("chrome://confirm-address/content/setting-add-domain.xul",
		"ConfirmAddressDialog", "chrome,modal,titlebar,centerscreen", window);

	if(window.confirmOK){
		var domainName = window.domainName;
		
		if(domainName.length > 0){
			dump("[add!] " + domainName + "\n");
			var groupList = document.getElementById("group-list");
			var listitem = document.createElement("listitem");
			listitem.setAttribute("id", Math.random());

			var cell1 = document.createElement("listcell");
			cell1.setAttribute("label", domainName);
			cell1.setAttribute("id", Math.random());
			listitem.appendChild(cell1);

			var cell2 = document.createElement("listcell");
			if(domainName.indexOf("@") != -1 ){
				cell2.setAttribute("label", addressstring );
			}else{
				cell2.setAttribute("label", domainstring  );
			}
			cell2.setAttribute("id", Math.random());
			listitem.appendChild(cell2);

			groupList.appendChild(listitem);
		}
	}
}
function edit(event){
	window.confirmOK = false;
	window.domainName = selectedItem.childNodes[0].getAttribute("label");
	window.openDialog("chrome://confirm-address/content/setting-add-domain.xul",
		"ConfirmAddressDialog", "chrome,modal,titlebar,centerscreen", window);

	if(window.confirmOK){
		var domainName = window.domainName;
		if(domainName.length > 0){
			dump("[edit!] " + domainName + "\n");
			var ndList = selectedItem.childNodes;
			ndList[0].setAttribute("label", domainName );
			if( domainName.indexOf("@") != -1 ){
				ndList[1].setAttribute("label", addressstring );
			}else{
				ndList[1].setAttribute("label", domainstring );
			}
		}
	}
}
function remove(event){
	var groupList = document.getElementById("group-list");
	dump("[remove] "+selectedItem + "\n");
	groupList.removeChild(selectedItem);
}

function selectList(item){
	selectedItem = item;
}

function doOK(){
	dump("[OK]\n");

	//ドメイン設定保存
	var domainList = new Array();
	var groupList = document.getElementById("group-list");
	var nodes = groupList.childNodes;
	for(i = 0; i < nodes.length; i++){
		if(nodes[i].nodeName == "listitem"){
			domainList.push(nodes[i].childNodes[0].getAttribute("label"));
		}
	}
	var domainListStr = domainList.join(",");
	nsPreferences.setUnicharPref(CA_CONST.DOMAIN_LIST, domainListStr);
	dump( "[domain]"+ domainListStr + "\n" );

	//チェックボックス設定保存
	nsPreferences.setBoolPref(CA_CONST.IS_CHECK_SENDER , document.getElementById("chk-sender" ).checked );
	nsPreferences.setBoolPref(CA_CONST.IS_CHECK_SUBJECT, document.getElementById("chk-subject").checked );
	nsPreferences.setBoolPref(CA_CONST.IS_NOT_DISPLAY  , document.getElementById("not-display").checked );
	nsPreferences.setBoolPref(CA_CONST.IS_COUNT_DOWN   , document.getElementById("countdown"  ).checked );
	nsPreferences.setBoolPref(CA_CONST.IS_SKIP_BUTTON  , document.getElementById("dspskipbtn" ).checked );

	var cdTime = document.getElementById("countdown-time").value;
	if(isNaN(Number(cdTime)) && isCountdown ){
		alert("please input integer");
		return false;
	}
	nsPreferences.setUnicharPref(CA_CONST.COUNT_DOWN_TIME, cdTime);

	return true;
}

function doCancel(){
	dump("[cancel]\n");
	return true;
}

